# coding: utf-8
lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'qiita_picks/version'

Gem::Specification.new do |spec|
  spec.name          = "qiita_picks"
  spec.version       = QiitaPicks::VERSION
  spec.authors       = ["Yoshiyuki Hirano"]
  spec.email         = ["info@henteco-labs.com"]
  spec.description   = %q{Generate PDF/HTML from articles posted on qiita.com. Uses wkhtmltopdf on the back-end which renders HTML using Webkit.}
  spec.summary       = %q{Generate PDF/HTML from articles posted on qiita.com.}
  spec.homepage      = "https://github.com/henteco-labs/qiita_picks"
  spec.license       = "MIT"
  spec.post_install_message = <<-EOF

qiita_picks installed! To get started fast:

  $ qiita_picks <URLs>

Or see the README.md at:

  https://github.com/henteco-labs/qiita_picks

EOF

  spec.add_dependency "nokogiri", "~> 1.6"
  spec.add_dependency "pdfkit", "~> 0.6"
  spec.add_dependency "ruby-gmail", "~> 0.3"
  spec.add_dependency "qiita", "~> 1.1"
  spec.add_dependency "activesupport", "~> 4.1"
  spec.add_dependency "baby_erubis", "~> 2.0"

  spec.add_development_dependency "bundler", "~> 1.7"
  spec.add_development_dependency "rake", "~> 10.0"
  spec.add_development_dependency "rspec", "~> 0"
  spec.add_development_dependency "pry", "~> 0"

  spec.files         = `git ls-files -z`.split("\x0")
  spec.executables   = spec.files.grep(%r{^bin/}) { |f| File.basename(f) }
  spec.test_files    = spec.files.grep(%r{^(test|spec|features)/})
  spec.require_paths = ["lib"]
end
